//----------------------------------------------------------------
// GUI main Frame
// Eksempler p brug af AWT komponenter
// Der er dog anvendt en enkelt swingkomponent - JPanel som kan give rammer med titel
// Hvis man anvender Panel istedet kan man ikke stte rammer og titel p
// Programmr: Bjrk Busch nov.2001
//----------------------------------------------------------------


// for oversigtens skyld er der der lavet import p de enkelte komponenter - ingen *
import javabook.Convert;
import java.awt.event.*;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import java.awt.Choice;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Button;
import java.awt.Label;
import java.awt.TextField;
import java.awt.List;
import java.awt.TextArea;

public	class GuiMainFrame extends Frame
{
	// Skrmdata
	private JPanel 		panel1			= new JPanel ();
	private JPanel 		panel1a			= new JPanel ();
	private JPanel 		panel1b			= new JPanel ();
	private JPanel 		panel1c			= new JPanel ();
	private JPanel 		panel1d			= new JPanel ();
	private JPanel 		panel1e			= new JPanel ();
	private JPanel 		panel1f			= new JPanel ();
	private JPanel 		panel2			= new JPanel ();
	private JPanel 		panel3			= new JPanel ();
	private JPanel 		panel4			= new JPanel ();

	private MenuBar		menuBar			= new MenuBar();
	private Menu			menu1				= new Menu("Popup memu");
	private MenuItem	menuItem1		= new MenuItem("Afls (menuitem)");

	private Choice 		combo1			= new Choice ();

	private CheckboxGroup  radioGroup1 = new CheckboxGroup();
	private Checkbox radio1   		= new Checkbox("Radio 1", radioGroup1, false);
	private Checkbox radio2   		= new Checkbox("Radio 1", radioGroup1, true);
	private Checkbox radio3   		= new Checkbox("Radio 1", radioGroup1, false);
	

	private Checkbox check1   		= new Checkbox("Check1", null, false);
	private Checkbox check2   		= new Checkbox("Check2", null, true);

	private Label 		label1			= new Label ("Label1:");
	private TextField tekst1			= new TextField ("",20);

	private List			listBox1	= new List(4, false); // 4 linier single valg
	private List			listBox2	= new List(4, true); 	// 4 linier multi valg

	private TextArea 	textArea1	= new TextArea ("Events\n",8,25); //8 linier  25 tegn
	private Button 		knap1		= new Button ("Afls (knap1)");




	public GuiMainFrame ()			/* constructor */
	{
		// opbygning af skrmbillede
		setSize(800,600);
		setTitle("Eksempel p grafiskbrugergrnseflade med AWT-komponenter  -   udarbejdet af Bjrk Busch");

		setMenuBar(menuBar);
		menuBar.add(menu1);
		menu1.add(menuItem1);
		menuItem1.addActionListener(new menuItem1ActionListener());

		//--------------------------------------------------------------------
		// opdeling af skrm i paneler
		setLayout(new GridLayout(2,2));

		panel1.setBorder(new TitledBorder(new EtchedBorder(),"Panel1-gruppe"));
		panel1.setLayout(new GridLayout(3,2));		
		add(panel1);

		panel1a.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel a"));
		panel1a.setLayout(new GridLayout(1,1));		
		panel1.add(panel1a);

		panel1b.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel b"));
		panel1b.setLayout(new GridLayout(1,2));		
		panel1.add(panel1b);

		panel1c.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel c"));
		panel1c.setLayout(new GridLayout(2,1));		
		panel1.add(panel1c);

		panel1d.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel d"));
		panel1d.setLayout(new GridLayout(1,1));		
		panel1.add(panel1d);
		
		panel1e.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel e"));
		panel1e.setLayout(new FlowLayout());		
		panel1.add(panel1e);
		
		panel1f.setBorder(new TitledBorder(new EtchedBorder(),"SubPanel f"));
		panel1f.setLayout(new FlowLayout());		
		panel1.add(panel1f);
		
		
		panel2.setBorder(new TitledBorder(new EtchedBorder(),"Panel2-gruppe"));
		panel2.setLayout(new GridLayout(1,1));		
		add(panel2);

		panel3.setBorder(new TitledBorder(new EtchedBorder(),"Panel3-gruppe"));
		panel3.setLayout(new GridLayout(1,2));		
		add(panel3);

		panel4.setBorder(new TitledBorder(new EtchedBorder(),"Panel4-gruppe"));
		panel4.setLayout(new GridLayout(1,1));		
		add(panel4);

		//--------------------------------------------------------------------
		// De "egentlige" skrmelementer tildeles vrdier og pladseres p skrmen

		combo1.addItem("Valg 1");
		combo1.addItem("Valg 2");
		combo1.addItem("Valg 3");
		combo1.select(1);			// default valg sttes til position 1 som er 2. element
		panel1a.add(combo1);


		panel1b.add(check1);
		panel1b.add(check2);


		panel1c.add(radio1);
		panel1c.add(radio2);
		panel1d.add(radio3);

		panel1e.add(label1);

		tekst1.setText("indhold i tekst");
		panel1f.add(tekst1);
		
		
		listBox1.add("singlevalgbox: 1. elm");
		listBox1.add("singlevalgbox: 2. elm");
		listBox1.add("singlevalgbox: 3. elm");
		listBox1.add("singlevalgbox: 4. elm");
		listBox1.add("singlevalgbox: 5. elm");
		listBox1.add("singlevalgbox: 6. elm");
		listBox1.select(1); 		// "default" valg er 2. element
		panel3.add(listBox1);

		listBox2.add("multivalgbox: 1. elm");
		listBox2.add("multivalgbox: 2. elm");
		listBox2.add("multivalgbox: 3. elm");
		listBox2.add("multivalgbox: 4. elm");
		listBox2.add("multivalgbox: 5. elm");
		panel3.add(listBox2);

		
		textArea1.setEditable(false);    // Tilad ikke skrivning i felt
		panel2.add(textArea1);

		panel4.add(knap1);
		knap1.addActionListener(new knap1ActionListener());



	}

	// metode til aflsning - kaldes fra menuItem/Button - ActionListener
  private void Aflaesning()
	{
			textArea1.append("Aflsninger:\n");

			textArea1.append("combo1: "+(String)combo1.getSelectedItem()+"\n");

			if (radio1.getState())
				textArea1.append("Radio 1 ON\n");
			else
				textArea1.append("Radio 1 OFF\n");

			if (radio2.getState())
				textArea1.append("Radio 2 ON\n");
			else
				textArea1.append("Radio 2 OFF\n");

			if (radio3.getState())
				textArea1.append("Radio 3 ON\n");
			else
				textArea1.append("Radio 3 OFF\n");

			if (check1.getState())
				textArea1.append("Check 1 ON\n");
			else
				textArea1.append("Check 1 OFF\n");

			if (check2.getState())
				textArea1.append("Check 2 ON\n");
			else
				textArea1.append("Check 2 OFF\n");

			textArea1.append("Tekst1 "+tekst1.getText()+"\n");

			textArea1.append("listbox1 valg index: "+listBox1.getSelectedIndex()+"\n");
			textArea1.append("listbox1 valg item: "+listBox1.getSelectedItem()+"\n");
		
			textArea1.append("listbox2 multivalg:\n");
			int []	valg2indexes = listBox2.getSelectedIndexes();
			for (int i = 0; i < valg2indexes.length; i++ )
				textArea1.append("listbox2 valg index: "+valg2indexes[i]+"\n");

			String []	valg2Items = listBox2.getSelectedItems();
			for (int i = 0; i < valg2Items.length; i++ )
			textArea1.append("listbox2 valg index: "+valg2Items[i]+"\n");
		
			textArea1.append("------------------------------\n");
		
	}

	private	class knap1ActionListener implements java.awt.event.ActionListener
	{
	  public void actionPerformed(ActionEvent e)
		{
 			textArea1.append("Knap1 aktiveret\n");
			Aflaesning();
		}
	}

	private	class menuItem1ActionListener implements java.awt.event.ActionListener
	{
	  public void actionPerformed(ActionEvent e)
		{
 			textArea1.append("menuItem1 aktiveret\n");
			Aflaesning();
		}
	}



} // slut p frame-klasse
